// This file is part of StarClassifier. Please see StarClassifier.java or 
// http://starclassifier.udd.be/ for license information. 
// Copyright (C) 2008 Niklas Udd

// This class represents a numeric node in the decision tree. Some extra functionality 
// which is not available in the super class is implemented here.

package be.udd.starclassifier;

public class DecisionNodeNumeric extends DecisionNode {
	int splitValue;

	public DecisionNodeNumeric(String name, int splitValue) {
		super(name);
		this.splitValue = splitValue;
	}
	
	public String getCondition() {
		return getCondition("<=");
	}
	
	public String getCondition(String edge) {
		// Edges can only be "<=" or ">" for numeric nodes
		
		if(edge.equals(">"))
			return getName() + " > " + splitValue;
		return getName() + " <= " + splitValue;
	}
	
	public DecisionTree classifyByValue(String valueString) {
		int value = Integer.parseInt(valueString);
		if(value <= splitValue)
			return classify("<=");
		else
			return classify(">");
	}
}