// This file is part of StarClassifier. Please see StarClassifier.java or 
// http://starclassifier.udd.be/ for license information. 
// Copyright (C) 2008 Niklas Udd

// This abstract class is the super class to DecisionNode and DecisionLeaf. It
// represents a decision tree. 

package be.udd.starclassifier;

public abstract class DecisionTree {
	private String name;
	
	public DecisionTree(String name) {
		this.name = name;
	}
	
	public String getName() {
		return name;
	}
	
	public String toString() {
		return toString("");
	}
	
	public String toWekaString() {
		return toWekaString("");
	}
	
	public abstract String toString(String prefix);
	public abstract String toWekaString(String prefix);
	public abstract int size();
	public abstract double getNumberOfExamples();
	public abstract double getNumberOfIncorrectExamples();	
	public abstract double getNumberOfExamplesInDefaultClass();
}