// This file is part of StarClassifier. Please see StarClassifier.java or 
// http://starclassifier.udd.be/ for license information. 
// Copyright (C) 2008 Niklas Udd

// This file loads a set of examples from a database and represents them as a Vector
// of Examples.

package be.udd.starclassifier;

import java.util.Vector;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;

public class ExampleSetLoader {
	public static Vector<Example > loadFromDb(DatabaseConfiguration dbConf) throws Exception {
		Vector<Example> exampleSet = new Vector<Example>();
				
		ResultSet result = dbConf.loadData();
		ResultSetMetaData metaData = result.getMetaData();
		
		while(result.next()) {
			Example example = new Example();			
			for(int i = 1; i <= metaData.getColumnCount(); i++) {
				Object object = result.getObject(i);
				if(object != null) {
					String objectString = object.toString();

					// Hack to make sure that 0 and 1 are perserved (and not changed
					// into false and true).
					if(metaData.getColumnClassName(i).equals("java.lang.Boolean"))
						objectString = ((Boolean)object)?"1":"0";

					example.setValue(metaData.getColumnName(i), objectString);
				}
			}
			exampleSet.add(example);			
		}
		
		result.close();
		
		return exampleSet;
	}
}